<?php

declare(strict_types=1);

namespace Dedi\SyliusMegamenuPlugin\Context;

use Dedi\SyliusMegamenuPlugin\Entity\MenuInterface;
use Dedi\SyliusMegamenuPlugin\Repository\MenuRepositoryInterface;
use Sylius\Component\Channel\Context\ChannelContextInterface;
use Sylius\Component\Core\Model\ChannelInterface;

final class MenuContext implements MenuContextInterface
{
    public function __construct(private ChannelContextInterface $channelContext, private MenuRepositoryInterface $menuRepository)
    {
    }

    public function getMenu(): ?MenuInterface
    {
        /** @var ChannelInterface $channel */
        $channel = $this->channelContext->getChannel();

        return $this->menuRepository->findForChannel($channel);
    }
}
